// RE:birth Ver1.3̃C^[tF[X
// OFG245Ƃ͐ʂ̌ZI݁B
// ANZX@Ⴄ炢ŁA{IȂƂOFG245Ƃقړ
// OFG245ƈāAeoX̏ݏf[^V[gʂɂȂ΂ȂȂB
// Latch2 -> Latch3(BSEL) -> Latch1 -> Latch3(WR)
/*
  0: D0
  1: D1
  2: D2
  3: D3
  4: Latch1 D0-D3,D4-D7
  5: Latch2 A0-A3,EXTSEL0-3
  6: Latch3 WR,-,IC,BSEL
  7: LED L:ON
*/


#include "s_re1.h"
#include "rv_util.h"
#include <windows.h>
#include <stdio.h>
#include "../ftd2xx.h"

// Œl`
#define	SENDDATAS	(65536)


// ϐ`
typedef struct re1if{
	Uint8	*sendbuffer;	//Mobt@|[gI[vtO
	Uint32	sendsize;
	Char	portstr[MAX_PORTSTR];
	Uint8	sn76489bf[MAX_SAMEDEVICES];
	Uint8	devnum;

	//Uint8	m_nOPNAtoOPND_cycle;

	FT_HANDLE	ftHandle;	//FTD Access Handle
	Uint8		portnum;	//Current Device Number
	Uint32		devbaud;	//Current Baud Rate

	Uint8 outnum[DEVIF_MAX][MAX_SAMEDEVICES];
	Uint8 outmax[DEVIF_MAX];
	Uint8 s_ChipReset;
	Uint8 s_OPNAtoOPND;
	Uint8 s_OPL3toOPL2;
	Uint8 s_OPNClock;
	Uint8 s_76489Fix;
	Char  s_Serial[17];
}IF_OBJ;

//============================================================================
// FT245{ANZX̂߂̊֐Q
//============================================================================

/*
------------------------------------------------------------------------------
FTDOpen
------------------------------------------------------------------------------
VAԍAfoCXT
------------------------------------------------------------------------------
F
  Char* ssn    VAԍ𕶎Ŏw
------------------------------------------------------------------------------
߂lF0ȏ̃foCXԍAȂ-1As-2
------------------------------------------------------------------------------
*/
static Int32 FTDSearchSN2Dev(Char* ssn){
	//FTDIvOt@X̃TvĎB
	FT_STATUS ret;
	FT_DEVICE_LIST_INFO_NODE *devi;
	Uint32 devnum;
	Int32 i;

	// 擾
	ret = FT_CreateDeviceInfoList(&devnum);
	if (ret != FT_OK) {
		return -2;
	}
	if (devnum > 0) {
		// 擾邽߂̃m
		devi = (FT_DEVICE_LIST_INFO_NODE*)malloc(sizeof(FT_DEVICE_LIST_INFO_NODE)*devnum);
		
		// mۂɏ˂
		ret = FT_GetDeviceInfoList(devi,&devnum);
		if (ret == FT_OK) {
			//ĒT
			for (i = devnum-1; i >= 0; i--) {
				if(!strcmp(ssn, devi[i].SerialNumber)){
					break;
				}
			}
			//Yꂸ
			free(devi);
			return i;
		}
	}else{
		return -1;
	}
}


/*
------------------------------------------------------------------------------
FTDOpen
------------------------------------------------------------------------------
FT245foCXI[vAANZX邽߂̏B
------------------------------------------------------------------------------
F
  void* obj    ϐIuWFNg
  Uint8 num    foCXԍBVAԍw肳Ăꍇ
  Uint32 baud  {[[gB0ɂƃftHglgB
------------------------------------------------------------------------------
߂lFȂ0AsȂ1
------------------------------------------------------------------------------
*/
static Uint8 FTDOpen(void* obj, Uint8 num, Uint32 baud){
	IF_OBJ *o = obj;
	FT_STATUS ftStatus;

	if(num == 0xff) num = 0;
	if(baud == 0) baud = 115200*2;

	FTDClose(obj);
	ftStatus = FT_Open(num, &o->ftHandle);
	if (ftStatus == FT_OK){
		ftStatus = FT_SetBaudRate(o->ftHandle, baud);
		if (ftStatus == FT_OK){
			ftStatus = FT_SetBitMode(o->ftHandle, 0x00, 0x0); //RESET
			ftStatus = FT_SetBitMode(o->ftHandle, 0xff, 0x1); //Asynchronous Bit Bang
			ftStatus = FT_SetTimeouts(o->ftHandle, 5000, 5000); //ms
			if (ftStatus == FT_OK){
				o->devnum = num;
				o->devbaud = baud;
				return 0;
			}
		}
	}
	o->devnum = 0xff;
	o->devbaud = 0;
	return 1;
}

/*
------------------------------------------------------------------------------
FTDClose
------------------------------------------------------------------------------
FT245B
------------------------------------------------------------------------------
F  void* obj    ϐIuWFNg
------------------------------------------------------------------------------
߂lFȂ
------------------------------------------------------------------------------
*/
static void FTDClose(void* obj){
	IF_OBJ *o = obj;
	if(o->ftHandle){
		FT_SetBitMode(o->ftHandle, 0x00, 0x0); //RESET
//		FT_ResetDevice(o->ftHandle);
//		FT_ResetPort(o->ftHandle);
//		FT_CyclePort(o->ftHandle);
		FT_Close(o->ftHandle);
	}
	o->ftHandle = 0;
}

/*
------------------------------------------------------------------------------
FTDWrite
------------------------------------------------------------------------------
FT245Ƀf[^o͂B
ȂAxsfoCXăI[vBiȉAOPj
------------------------------------------------------------------------------
F
  void* obj     ϐIuWFNg
  Uint8 *data	o͂f[^
  Uint32 bytes	o͂f[^̃TCY
------------------------------------------------------------------------------
߂lFȂ0AsȂ1
------------------------------------------------------------------------------
*/
static Uint8 FTDWrite(void* obj, Uint8 *data, Uint32 bytes){
	IF_OBJ *o = obj;
	Uint32 writebyte;
	if(!o->ftHandle) return 1;
	
	if(FT_Write(o->ftHandle, data, bytes, &writebyte) == FT_OK){
		return 0;
	}
	//CgɎsAN[YB
	FTDClose(obj);
	//if(FTDOpen(devnum, devbaud) == 0){
	//	if(FT_Write(o->ftHandle, data, bytes, &writebyte) == FT_OK){
	//		return 0;
	//	}
	//}
	return 1;
}


/*
------------------------------------------------------------------------------
FTDWrite1
------------------------------------------------------------------------------
FT245Ƀf[^1oCgo͂B
OP
------------------------------------------------------------------------------
F
  void* obj     ϐIuWFNg
  Uint8 data	o͂f[^
------------------------------------------------------------------------------
߂lFȂ0AsȂ1
------------------------------------------------------------------------------
*/
static Uint8 FTDWrite1(void* obj, Uint8 data){
	IF_OBJ *o = obj;
	Uint8 writedata[1];
	if(!o->ftHandle) return 1;
	
	writedata[0] = data;
	
	return FTDWrite(obj, (Uint8 *)&writedata, 1);
}


/*
------------------------------------------------------------------------------
FTDRead
------------------------------------------------------------------------------
FT245Ƀf[^o͂B
ȂAxsfoCXăI[vBiȉAOPj
------------------------------------------------------------------------------
F
  void* obj     ϐIuWFNg
  BYTE *data	o͂f[^
  DWORD bytes	o͂f[^̃TCY
------------------------------------------------------------------------------
߂lFȂ0AsȂ1
------------------------------------------------------------------------------
*/
static Uint8 FTDRead(void* obj, Uint8 *data, Uint32 bytes){
	IF_OBJ *o = obj;
	Uint32 readbyte;
	if(!o->ftHandle) return 1;
	
	if(FT_Read(o->ftHandle, data, bytes, &readbyte) == FT_OK){
		return 0;
	}
	//[hɎsAN[YB
	FTDClose(obj);
	return 1;
}

/*
------------------------------------------------------------------------------
FTDRead1
------------------------------------------------------------------------------
FT245f[^1oCgǂށB
OP
------------------------------------------------------------------------------
F
  void* obj     ϐIuWFNg
  Uint8 data	o͂f[^
------------------------------------------------------------------------------
߂lFȂ0AsȂ1
------------------------------------------------------------------------------
*/
static Uint8 FTDRead1(void* obj){
	IF_OBJ *o = obj;
	Uint8 readdata[1];
	if(!o->ftHandle) return 1;
	
	FTDRead(obj, &readdata, 1);
	return readdata[0];
}



//============================================================================
// 特ANZX̂߂̊֐Q
//============================================================================

/*
------------------------------------------------------------------------------
LoadSetting
------------------------------------------------------------------------------
RE1-IF̂߂̐ݒǂݍށB
݂̃R[hł́AOSɈˑB
------------------------------------------------------------------------------
F
  void* obj     ϐIuWFNg
  Uint8 num	|[gԍ
------------------------------------------------------------------------------
߂lFȂ
------------------------------------------------------------------------------
*/
static void LoadSetting(void* obj, Uint8 num){
	IF_OBJ *o = obj;
	Char inifile[MAX_PATH];
	Char secname[11]; //"RE1-xxx"
	Char keyname[15]; //"OUT_YM2413_255"
	Uint8 wfg=0,a,b;
	Uint32 i;
	INIFILE *ifi;

	//ݒt@CpX
	strcpy(inifile, curdir);
	strcat(inifile, DIRSEP IFINI_NAME ".ini");

	//O[v
	sprintf(secname, "RE1-%d",num+1);

	//ݒǂݍ
	ifi = OpenIniFile(inifile);

	o->s_Serial[0]=0;
	ReadWriteIniString(ifi,secname,"SN",17,o->s_Serial);

	o->s_ChipReset  = ReadWriteIniVal(ifi,secname,"ChipReset ",1);
	o->s_OPNAtoOPND = ReadWriteIniVal(ifi,secname,"OPNAtoOPND",0);
	o->s_OPL3toOPL2 = ReadWriteIniVal(ifi,secname,"OPL3toOPL2",0);
	o->s_OPNClock   = ReadWriteIniVal(ifi,secname,"OPNClock  ",0);
	o->s_76489Fix   = ReadWriteIniVal(ifi,secname,"76489Fix  ",1);

	//o̓|[gǂݍ݁B
	for(a=0;a<DEVIF_MAX;a++){
		for(b=0;b<MAX_SAMEDEVICES;b++){
			sprintf(keyname, "OUT_%s_%-2d",DEVIF_ChipStr[a],b+1);
			//2߂܂ł͖ꍇ͒ǉBȍ~͂ΓǂށB
			if(b<2){
				o->outnum[a][b] = ReadWriteIniVal(ifi,secname,keyname,0);
			}else{
				i = ReadIniVal(ifi, secname, keyname ,0 ,0);
				if(i>255){
					//ݒ肪Ȃꍇ
					o->outmax[a] = b;
					break;
				}else{
					o->outnum[a][b] = i;
				}
			}
			//BSELЂԂ
			o->outnum[a][b] ^= 16;
		}
		for(;b<MAX_SAMEDEVICES;b++){
			o->outnum[a][b] = 16;
		}
	}
	CloseIniFile(ifi);
}

/*
------------------------------------------------------------------------------
ifsend
------------------------------------------------------------------------------
[J֐]
ߍ񂾃Cgf[^𑗐MB
------------------------------------------------------------------------------
F
  void* obj     ϐIuWFNg
------------------------------------------------------------------------------
߂lFȂ0AsȂ炻ȊO
------------------------------------------------------------------------------
*/
static Uint8 ifsend(void* obj){
	IF_OBJ *o = obj;

	if(o->sendsize > 0){
		FTDWrite(obj, o->sendbuffer, o->sendsize);
		o->sendsize = 0;
	}
	return 0;
}


#define ADDSENDDATALIST(x) {o->sendbuffer[o->sendsize++]=x;if(o->sendsize>=SENDDATAS)ifsend(obj);}
/*
------------------------------------------------------------------------------
push
------------------------------------------------------------------------------
[J֐]
Cgf[^𗭂ߍށB
------------------------------------------------------------------------------
F
  void* obj     ϐIuWFNg
  Uint8 chip    `bv̎
  Uint8 num     ԍB̉ԖڂB|0x80Ńpb`B
  Uint8 abus    AhXoXw
  Uint8 addr    WX^̃AhXw
  Uint8 val     WX^̒lw
------------------------------------------------------------------------------
߂lFȂ0AsȂ炻ȊO
------------------------------------------------------------------------------
*/
static Uint8 push(void* obj, Uint8 chip, Uint8 num, Uint8 abus, Uint8 addr, Uint8 val){
	IF_OBJ *o = obj;
	Uint8 swait, d=0x00,a=0,v,w=0;
	//w 0:ʏ탉Cg 1:SN76489Cg 2:OPNA2OPN2Cg

	if(chip >= DEVIF_MAX) return 1;
	if(num  >= MAX_SAMEDEVICES) return 1;

	d = o->outnum[chip][num];
	a = abus<<1;

	//foCXI𕔕Bȏ镨̂
	switch(chip){
		case DEVIF_YM2608:
		case DEVIF_YM2610:
			if(o->s_OPNAtoOPND){
				w = 2;//OPNAtoOPNDpb`̑Ώ
			}else{
				w = 0;
			}
		case DEVIF_YM2612:
			if(o->s_OPNAtoOPND){
				w = 2;//OPNAtoOPNDpb`̑Ώ
			}else{
				w = 10;
			}
			break;
		case DEVIF_AY8910:
			w = 3;//PSG̏
			break;
		case DEVIF_YM2203:
			//NbNݒ𖳎pb`
			if(num < 128 && o->s_OPNClock)
				if(addr>0x2c && addr<0x30) return TRUE;
			break;
		case DEVIF_YMF262:
			//OPL3toOPL2pb`
			if(o->s_OPL3toOPL2){
				if(o->s_OPL3toOPL2 > MAX_SAMEDEVICES) return 1;
				if(a){
					d = o->outnum[DEVIF_YM3812][o->s_OPL3toOPL2 -1];
				}else{
					d = o->outnum[DEVIF_YM3812][o->s_OPL3toOPL2 -0];
				}
			}
			break;
		case DEVIF_SN76489:
			a = 0xff; w = 1;//SN76489p̏
			if(num < 128 && o->s_76489Fix){
				//ŁAg000001ɂւpb`B
				if(o->sn76489bf[num]){
					Uint8 bf;
					if((o->sn76489bf[num]&0xf) | val){
						bf = o->sn76489bf[num];
					}else{
						bf = o->sn76489bf[num] | 0x01;
					}
					push(obj, chip, num|0x80, 0, a, bf);
					o->sn76489bf[num] = 0;
				}else{
					if((val&0x1f) == 0){
						o->sn76489bf[num] = val;
						return TRUE;
					}
				}
			}			
			break;
	}

	if(o->sendsize >= (SENDDATAS - 200)) {
		ifsend(obj);
	}


	//悢惉Cg
	if(w==2){
		//YM2612YM2203x2łނȂ炷Ղ낮ށ[II
		if(a){
			if(addr >= 0x30){
				return push(obj, DEVIF_YM2203,o->s_OPNAtoOPND-0,0,addr,val);
			}
		}else{
			if(addr == 0x28){
				if(val & 4){
					//4-6chڂ̐悤ƂĂȂAւĂ܂I
					val = val & 0xf7;
					return push(obj, DEVIF_YM2203,o->s_OPNAtoOPND-0,0,addr,val);
				}else{
					return push(obj, DEVIF_YM2203,o->s_OPNAtoOPND-1,0,addr,val);
				}
			}else
			if(addr == 0x2a){
				//YM2612DACSSGŖ炻
				
				const Uint8 DAC2SSGtbl[][2]={
					/*//z͂̃e[uBłƏAmCYoB
					1,0, 1,0, 2,0, 2,1, 3,0, 3,1, 4,0, 4,1, 
					5,0, 5,1, 5,2, 6,0, 6,0, 6,1, 6,2, 7,0, 
					7,0, 7,1, 7,2, 7,3, 7,3, 7,4, 7,4, 8,0, 
					8,1, 8,2, 8,3, 8,3, 7,6, 8,4, 9,0, 9,0, 

					9,1, 9,2, 9,3, 9,3, 9,4, 9,4, 9,5, 9,5, 
					9,6, 9,6, 9,6, 9,6, 10,0, 10,1, 10,2, 9,7, 
					10,3, 10,4, 10,4, 10,5, 10,5, 9,8, 9,8, 10,6, 
					10,6, 11,0, 11,0, 11,0, 11,1, 11,2, 9,9, 11,3, 
					11,4, 11,4, 11,5, 11,5, 11,6, 11,6, 11,6, 11,6, 
					11,7, 11,7, 11,7, 11,7, 11,8, 11,8, 11,8, 11,8, 
					11,8, 11,8, 11,8, 10,10, 10,10, 10,10, 10,10, 10,10, 
					10,10, 11,9, 11,9, 12,0, 12,1, 12,1, 12,2, 12,3, 
					12,3, 12,4, 12,4, 12,5, 12,5, 11,10, 11,10, 11,10, 
					12,6, 12,7, 12,7, 12,7, 12,7, 13,0, 13,0, 13,0, 
					13,0, 13,0, 13,0, 12,8, 13,2, 13,3, 13,3, 13,4, 
					13,4, 13,5, 13,5, 12,9, 13,6, 13,6, 13,6, 13,7, 
					13,7, 13,7, 13,7, 12,10, 12,10, 12,10, 12,10, 12,10, 
					12,10, 13,8, 13,9, 13,9, 13,9, 13,9, 13,9, 13,9, 
					13,9, 13,9, 12,11, 12,11, 12,11, 12,11, 12,11, 12,11, 
					13,10, 13,10, 13,10, 13,10, 13,10, 13,10, 13,10, 14,0, 
					14,0, 14,0, 14,0, 14,1, 14,2, 14,3, 14,3, 14,4, 
					14,4, 14,5, 14,5, 13,11, 13,11, 13,11, 14,6, 14,7, 
					14,7, 14,7, 14,7, 12,12, 12,12, 12,12, 12,12, 12,12, 
					14,8, 14,8, 14,9, 14,9, 14,9, 14,9, 14,9, 14,9, 
					14,9, 14,9, 13,12, 13,12, 13,12, 13,12, 13,12, 13,12, 
					13,12, 13,12, 13,12, 13,12, 13,12, 13,12, 13,12, 15,0, 
					15,0, 15,0, 15,0, 15,0, 15,0, 15,0, 15,0, 15,0, 
					15,0, 15,1, 15,1, 15,2, 15,3, 15,3, 15,4, 15,4, 
					15,5, 15,5, 13,13, 13,13, 13,13, 15,6, 15,7, 15,7, 
					15,7, 15,7, 15,8, 15,8, 15,8, 15,8, 15,8, 15,8, 
					15,8, 15,9, 15,9, 15,9, 15,9, 15,9, 15,9, 15,9, 
					15,9, 14,12, 14,12, 14,12, 14,12, 14,12, 14,12, 15,10, 
					*/
					1,0, 2,0, 2,1, 2,2, 3,2, 4,1, 5,2, 5,2, 
					5,3, 5,4, 6,3, 6,3, 6,4, 6,5, 7,4, 7,4, 
					7,5, 7,6, 7,6, 7,6, 8,5, 8,5, 8,6, 8,6, 
					8,7, 8,7, 8,7, 9,6, 9,6, 9,6, 8,8, 8,8, 
					9,8, 9,8, 9,8, 9,8, 9,8, 10,7, 10,7, 10,7, 
					10,7, 9,9, 10,8, 10,8, 10,8, 10,8, 10,9, 10,9, 
					10,9, 10,9, 10,9, 11,8, 11,8, 11,8, 11,8, 11,8, 
					10,10, 10,10, 10,10, 10,10, 11,9, 11,10, 11,10, 11,10, 
					11,10, 11,10, 11,10, 11,10, 11,10, 11,10, 11,11, 11,11, 
					11,11, 11,11, 11,11, 11,11, 11,11, 11,11, 11,11, 11,11, 
					12,9, 12,9, 12,9, 12,10, 12,10, 12,10, 12,10, 12,10, 
					12,10, 12,10, 12,10, 12,11, 12,11, 12,11, 12,11, 12,11, 
					12,11, 12,11, 12,11, 12,11, 12,11, 13,10, 13,10, 13,10, 
					13,10, 13,10, 13,11, 13,11, 13,11, 13,11, 13,11, 13,11, 
					13,11, 13,11, 13,11, 13,11, 12,12, 12,12, 12,12, 12,12, 
					12,12, 12,12, 12,12, 13,12, 13,12, 13,12, 13,12, 13,12, 
					13,12, 13,12, 13,12, 13,12, 13,12, 13,12, 13,12, 13,12, 
					13,12, 13,12, 14,11, 14,11, 14,11, 14,11, 14,11, 14,11, 
					14,11, 14,11, 14,11, 14,11, 13,13, 13,13, 13,13, 13,13, 
					13,13, 14,12, 14,12, 14,12, 14,12, 14,12, 14,12, 14,12, 
					14,12, 14,12, 14,12, 14,12, 14,12, 14,12, 14,12, 14,12, 
					14,12, 14,12, 14,13, 14,13, 14,13, 14,13, 14,13, 14,13, 
					14,13, 14,13, 14,13, 14,13, 14,13, 14,13, 14,13, 14,13, 
					14,13, 15,12, 15,12, 15,12, 15,12, 15,12, 15,12, 15,12, 
					15,12, 15,12, 15,12, 15,12, 15,12, 15,12, 15,12, 15,12, 
					15,12, 15,12, 15,12, 15,12, 15,12, 15,12, 14,14, 14,14, 
					14,14, 14,14, 14,14, 14,14, 14,14, 14,14, 14,14, 14,14, 
					14,14, 15,13, 15,13, 15,13, 15,13, 15,14, 15,14, 15,14, 
					15,14, 15,14, 15,14, 15,14, 15,14, 15,14, 15,14, 15,14, 
					15,14, 15,14, 15,14, 15,14, 15,14, 15,14, 15,14, 15,14, 
					15,14, 15,14, 15,14, 15,14, 15,14, 15,14, 15,14, 15,14, 
					15,14, 15,14, 15,14, 15,14, 15,14, 15,15, 15,15, 15,15, 

				};
				//ڏāAɌ܂ōœK
				d = o->outnum[DEVIF_YM2203][o->s_OPNAtoOPND -0];
				a = 0; v = 0x08;
				//Latch2(A,EXTSEL)
				ADDSENDDATALIST((a&15)|0x50);
				ADDSENDDATALIST((a&15)|0x70);
				ADDSENDDATALIST((d&15)|0x50);
				ADDSENDDATALIST((d&15)|0x70);
				//Latch3(BSEL)
				ADDSENDDATALIST(((d&16)>>1)|0x37);
				ADDSENDDATALIST(((d&16)>>1)|0x77);
				//Latch1(D)
				ADDSENDDATALIST((v&15)|0x60);
				ADDSENDDATALIST((v&15)|0x70);
				ADDSENDDATALIST((v>>4)|0x60);
				ADDSENDDATALIST((v>>4)|0x70);
				//Latch3
				ADDSENDDATALIST(((d&16)>>1)|0x36);
				ADDSENDDATALIST(((d&16)>>1)|0x76);
				ADDSENDDATALIST(((d&16)>>1)|0x37);
				ADDSENDDATALIST(((d&16)>>1)|0x77);
				a++; v = DAC2SSGtbl[val][0];
				//Latch2(A,EXTSEL)
				ADDSENDDATALIST((a&15)|0x50);
				ADDSENDDATALIST((a&15)|0x70);
				ADDSENDDATALIST((d&15)|0x50);
				ADDSENDDATALIST((d&15)|0x70);
				//Latch1(D)
				ADDSENDDATALIST((v&15)|0x60);
				ADDSENDDATALIST((v&15)|0x70);
				ADDSENDDATALIST((v>>4)|0x60);
				ADDSENDDATALIST((v>>4)|0x70);
				//Latch3
				ADDSENDDATALIST(((d&16)>>1)|0x36);
				ADDSENDDATALIST(((d&16)>>1)|0x76);
				ADDSENDDATALIST(((d&16)>>1)|0x37);
				ADDSENDDATALIST(((d&16)>>1)|0x77);
				a = 0; v = 0x09;
				//Latch2(A,EXTSEL)
				ADDSENDDATALIST((a&15)|0x50);
				ADDSENDDATALIST((a&15)|0x70);
				ADDSENDDATALIST((d&15)|0x50);
				ADDSENDDATALIST((d&15)|0x70);
				//Latch1(D)
				ADDSENDDATALIST((v&15)|0x60);
				ADDSENDDATALIST((v&15)|0x70);
				ADDSENDDATALIST((v>>4)|0x60);
				ADDSENDDATALIST((v>>4)|0x70);
				//Latch3
				ADDSENDDATALIST(((d&16)>>1)|0x36);
				ADDSENDDATALIST(((d&16)>>1)|0x76);
				ADDSENDDATALIST(((d&16)>>1)|0x37);
				ADDSENDDATALIST(((d&16)>>1)|0x77);
				a++; v = DAC2SSGtbl[val][1];
				//Latch2(A,EXTSEL)
				ADDSENDDATALIST((a&15)|0x50);
				ADDSENDDATALIST((a&15)|0x70);
				ADDSENDDATALIST((d&15)|0x50);
				ADDSENDDATALIST((d&15)|0x70);
				//Latch1(D)
				ADDSENDDATALIST((v&15)|0x60);
				ADDSENDDATALIST((v&15)|0x70);
				ADDSENDDATALIST((v>>4)|0x60);
				ADDSENDDATALIST((v>>4)|0x70);
				//Latch3
				ADDSENDDATALIST(((d&16)>>1)|0x36);
				ADDSENDDATALIST(((d&16)>>1)|0x76);
				ADDSENDDATALIST(((d&16)>>1)|0x37);
				ADDSENDDATALIST(((d&16)>>1)|0xf7);
				return TRUE;
			}else{
				if(addr >= 0x20 || addr <= 0x0d){
					return push(obj, DEVIF_YM2203,o->s_OPNAtoOPND-1,0,addr,val);
				}
			}
		}
	}
	if(w==0||w>5){
		//ʏ̏BFMƂ͂
		v = addr;
		//Latch2(A,EXTSEL)
		ADDSENDDATALIST((a&15)|0x50);
		ADDSENDDATALIST((a&15)|0x70);
		ADDSENDDATALIST((d&15)|0x50);
		ADDSENDDATALIST((d&15)|0x70);
		//Latch3(BSEL)
		ADDSENDDATALIST(((d&16)>>1)|0x37);
		ADDSENDDATALIST(((d&16)>>1)|0x77);
		//Latch1(D)
		ADDSENDDATALIST((v&15)|0x60);
		ADDSENDDATALIST((v&15)|0x70);
		ADDSENDDATALIST((v>>4)|0x60);
		ADDSENDDATALIST((v>>4)|0x70);
		//Latch3
		for(swait=0;swait<20;swait++)ADDSENDDATALIST(((d&16)>>1)|0x36);
		for(swait=0;swait<8;swait++)ADDSENDDATALIST(((d&16)>>1)|0x76);
		ADDSENDDATALIST(((d&16)>>1)|0x37);
		ADDSENDDATALIST(((d&16)>>1)|0x77);

		a++; v = val;
		//Latch2(A,EXTSEL)
		ADDSENDDATALIST((a&15)|0x50);
		ADDSENDDATALIST((a&15)|0x70);
		ADDSENDDATALIST((d&15)|0x50);
		ADDSENDDATALIST((d&15)|0x70);
		//Latch3(BSEL)
		ADDSENDDATALIST(((d&16)>>1)|0x37);
		ADDSENDDATALIST(((d&16)>>1)|0x77);
		//Latch1(D)
		ADDSENDDATALIST((v&15)|0x60);
		ADDSENDDATALIST((v&15)|0x70);
		ADDSENDDATALIST((v>>4)|0x60);
		ADDSENDDATALIST((v>>4)|0x70);
		//Latch3
		for(swait=0;swait<20;swait++)ADDSENDDATALIST(((d&16)>>1)|0x36);
		if(chip==DEVIF_YM2612){
			//MDɍœKEFCg
			for(swait=0;swait<26;swait++)ADDSENDDATALIST(((d&16)>>1)|0x76);
		}else{
			if(w){
				for(swait=0;swait<w;swait++)ADDSENDDATALIST(((d&16)>>1)|0x76);
			}else{
				for(swait=0;swait<22;swait++)ADDSENDDATALIST(((d&16)>>1)|0x76);
		
			}
		}
		ADDSENDDATALIST(((d&16)>>1)|0x37);
		ADDSENDDATALIST(((d&16)>>1)|0xf7);
	}else if(w==3){
		//PSG̏
		v = addr;
		//Latch2(A,EXTSEL)
		ADDSENDDATALIST((a&15)|0x50);
		ADDSENDDATALIST((a&15)|0x70);
		ADDSENDDATALIST((d&15)|0x50);
		ADDSENDDATALIST((d&15)|0x70);
		//Latch3(BSEL)
		ADDSENDDATALIST(((d&16)>>1)|0x37);
		ADDSENDDATALIST(((d&16)>>1)|0x77);
		//Latch1(D)
		ADDSENDDATALIST((v&15)|0x60);
		ADDSENDDATALIST((v&15)|0x70);
		ADDSENDDATALIST((v>>4)|0x60);
		ADDSENDDATALIST((v>>4)|0x70);
		//Latch3
		ADDSENDDATALIST(((d&16)>>1)|0x36);
		ADDSENDDATALIST(((d&16)>>1)|0x76);
		ADDSENDDATALIST(((d&16)>>1)|0x37);
		for(swait=0;swait<10;swait++)ADDSENDDATALIST(((d&16)>>1)|0x77);

		a++; v = val;
		//Latch2(A,EXTSEL)
		ADDSENDDATALIST((a&15)|0x50);
		ADDSENDDATALIST((a&15)|0x70);
		ADDSENDDATALIST((d&15)|0x50);
		ADDSENDDATALIST((d&15)|0x70);
		//Latch1(D)
		ADDSENDDATALIST((v&15)|0x60);
		ADDSENDDATALIST((v&15)|0x70);
		ADDSENDDATALIST((v>>4)|0x60);
		ADDSENDDATALIST((v>>4)|0x70);
		//Latch3
		ADDSENDDATALIST(((d&16)>>1)|0x36);
		ADDSENDDATALIST(((d&16)>>1)|0x76);
		ADDSENDDATALIST(((d&16)>>1)|0x37);
		for(swait=0;swait<10;swait++)ADDSENDDATALIST(((d&16)>>1)|0x77);
		ADDSENDDATALIST(((d&16)>>1)|0xf7);
	}else{
		//SN76489̏
		a = 0;
		v = val;
		//Latch2(A,EXTSEL)
		ADDSENDDATALIST((a&15)|0x50);
		ADDSENDDATALIST((a&15)|0x70);
		ADDSENDDATALIST((d&15)|0x50);
		ADDSENDDATALIST((d&15)|0x70);
		//Latch3(BSEL)
		ADDSENDDATALIST(((d&16)>>1)|0x37);
		ADDSENDDATALIST(((d&16)>>1)|0x77);
		//Latch1(D)
		ADDSENDDATALIST((v&15)|0x60);
		ADDSENDDATALIST((v&15)|0x70);
		ADDSENDDATALIST((v>>4)|0x60);
		ADDSENDDATALIST((v>>4)|0x70);
		//Latch3
		ADDSENDDATALIST(((d&16)>>1)|0x36);
		for(swait=0;swait<40;swait++)ADDSENDDATALIST(((d&16)>>1)|0x76);
		ADDSENDDATALIST(((d&16)>>1)|0x37);
		ADDSENDDATALIST(((d&16)>>1)|0x77);
		ADDSENDDATALIST(((d&16)>>1)|0xf7);
	}
	return	TRUE;
}


/*
------------------------------------------------------------------------------
reset
------------------------------------------------------------------------------
[J֐]
ZbgR}h𔭍sB
------------------------------------------------------------------------------
F
  void* obj     ϐIuWFNg
------------------------------------------------------------------------------
߂lFȂ0AsȂ炻ȊO
------------------------------------------------------------------------------
*/
// 
static Uint8 reset(void* obj){
	IF_OBJ *o = obj;
	Uint8 i;
	ifsend(obj);
	
	if(!o->ftHandle){
		//ڑ؂ĂĐڑ
		FTDOpen(obj, o->devnum, o->devbaud);
	}
	//Őݒ胍[h
	LoadSetting(obj, o->portnum);

	if(o->s_ChipReset){
		const Uint8 writedata[]={
			0x3b,0x7b,0x7b,0x7b,0x7b,0x7b,0x7b,0x7b,
			0x7b,0x7b,0x7b,0x7b,0x7b,0x7b,0x7b,0x7b,
			0x7b,0x7b,0x7b,0x7b,0x7b,0x7b,0x7b,0x7b,
			0x7b,0x7b,0x7b,0x7b,0x7b,0x7b,0x7b,0x7b,
			0x7b,0x7b,0x7b,0x7b,0x7b,0x7b,0x7b,0x7b,
			0x7b,0x7b,0x7b,0x7b,0x7b,0x7b,0x7b,0x7b,
			0x7b,0x7b,0x7b,0x7b,0x7b,0x7b,0x7b,0x7b,
			0x7b,0x7b,0x7b,0x7b,0x7b,0x7b,0x7b,0x7b,
			0x7b,0x7b,0x7b,0x7b,0x7b,0x7b,0x7b,0x7b,
			0x3f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,
			0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,
			0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,
			0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,
			0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,
			0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,
			0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,
			0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,
			0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,
			0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,
			0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,
			0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,
			0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,
			0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,
			0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,
			0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,
			0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,
			0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,
			0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,
			0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,
			0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,
			0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,
			0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,
			0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,
			0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,
			0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,
			0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,
			0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,
			0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,
			0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,
			0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,
			0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,
			0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,
			0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,
			0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,
			0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,
			0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,
			0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,
			0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0x7f,0xff,
		};
		//SN76489p̃Zbg
		for(i=0; i<o->outmax[DEVIF_SN76489]; i++){
			push(obj, DEVIF_SN76489, i, 0x00, 0x00, 0x9f);
			push(obj, DEVIF_SN76489, i, 0x00, 0x00, 0xbf);
			push(obj, DEVIF_SN76489, i, 0x00, 0x00, 0xdf);
			push(obj, DEVIF_SN76489, i, 0x00, 0x00, 0xff);
		}
		ifsend(obj);
		//D-FF2ȗĂ̂߂/ICMo
		FTDRead(obj, o->sendbuffer, 2048);
		//ZbgpR}hM
		FTDWrite(obj, (Uint8 *)&writedata, sizeof(writedata));


	}
	//YM2203̃NbNݒ
	if(o->s_OPNClock){
		for(i=0; i<o->outmax[DEVIF_YM2203]; i++){
			switch(o->s_OPNClock){
			case 1:
				push(obj, DEVIF_YM2203, i|0x80, 0x00, 0x2f, 0);
				push(obj, DEVIF_YM2203, i|0x80, 0x00, 0x2e, 0);
				break;
			case 2:
				push(obj, DEVIF_YM2203, i|0x80, 0x00, 0x2e, 0);
				push(obj, DEVIF_YM2203, i|0x80, 0x00, 0x2d, 0);
				break;
			case 3:
				push(obj, DEVIF_YM2203, i|0x80, 0x00, 0x2f, 0);
				push(obj, DEVIF_YM2203, i|0x80, 0x00, 0x2d, 0);
				break;
			}
		}
	}
	//OPNA2OPN2łSSG
	if(o->s_OPNAtoOPND){
		push(obj, DEVIF_YM2203, o->s_OPNAtoOPND-0, 0x00, 0x07, 0x3f);
		push(obj, DEVIF_YM2203, o->s_OPNAtoOPND-0, 0x00, 0x08, 0);
		push(obj, DEVIF_YM2203, o->s_OPNAtoOPND-0, 0x00, 0x09, 0);
		push(obj, DEVIF_YM2203, o->s_OPNAtoOPND-0, 0x00, 0x0a, 0);
	}

	for(i=0; i<o->outmax[DEVIF_SN76489]; i++){
		o->sn76489bf[i] = 0;
	}
	return TRUE;
}



static Uint8 open(void* obj, Uint8 portnum){
	IF_OBJ *o = obj;
	Int32 cnt;
	Char* cDevName[11];

	//Őݒ胍[h
	o->portnum = portnum;
	LoadSetting(obj, o->portnum);

	if(o->s_Serial[0]){
		//VAԍ̎w肪ATB
		cnt = FTDSearchSN2Dev(o->s_Serial);
		if(cnt>=0){
			if(FTDOpen(obj,cnt,0)){
				//I[vsG[
				cnt = 256;
			}
		}else{
			//w̃VAԍ̃foCXȂꍇG[
			cnt = 256;
		}
	}else{
		//VAԍ̎w肪Ȃꍇ́A[vŃ|[gT
		for(cnt = 0; cnt <= 255; cnt++){
			if(!FTDOpen(obj,cnt,0))break;
		}
	}
	// |[gJȂꍇ
	if(cnt > 255){
		strcpy(o->portstr,"Error");
		MessageBeep(0);
		o->sendbuffer	= NULL;
		return 1;
	}
	sprintf(o->portstr,"Dev:%d",cnt);
	// Mp̃WX^obt@ݒ
	o->sendbuffer	= malloc(SENDDATAS);

	reset(obj);
	return 0;
}

static Uint8 close(void* obj){
	IF_OBJ *o = obj;

	if(o){
		if(o->sendbuffer){
			reset(obj);

			FTDClose(obj); // FTfoCX
			free(o->sendbuffer);
			o->sendbuffer = 0;
		}

		//IuWFNgI
		free(o);
		o = 0;
	}
	return 0;
}

static Uint8 info(void* obj, Char* sp){
	IF_OBJ *o = obj;
	return strcpy(sp,o->portstr);
}

Uint8 s_re1_new(SEND_INTERFACE *i){
	i->open  = *open;
	i->close = *close;
	i->reset = *reset;
	i->push  = *push;
	i->send  = *ifsend;
	i->info  = *info;
	i->p     = malloc(sizeof(IF_OBJ));
	return 0;
}

