#include "rv_util.h"

#ifdef __cplusplus
extern "C" {
#endif

#ifndef __RV_INTERFACE
#define __RV_INTERFACE 1

//萔`
//--------------------------------------
//MIF̍ő
#define SENDIF_MAX 64
//fR[hvO̍ő吔
#define DECODEIF_MAX 2
//|[g̍ő啶iNULL܂ށj
#define MAX_PORTSTR 20
//̍ő吔
#define MAX_SAMEDEVICES 64

//foCXʁB
enum{
//	DEVIF_BEEPAT,
//	DEVIF_BEEP98,
	DEVIF_SN76489,
	DEVIF_YM2413,
	DEVIF_YM2612,
	DEVIF_YM2151,
//	DEVIF_SEGAPCM,
//	DEVIF_RF5C68,
	DEVIF_YM2203,
	DEVIF_YM2608,
	DEVIF_YM2610,
	DEVIF_YM3812,
	DEVIF_YM3526,
	DEVIF_Y8950,
	DEVIF_YMF262,
	DEVIF_YMF278B,
	DEVIF_YMF271,
//	DEVIF_YMZ280B,
//	DEVIF_RF5C164,
//	DEVIF_PWM,
	DEVIF_AY8910,
//	DEVIF_DMG,
//	DEVIF_RP2A03,
//	DEVIF_MULTIPCM,
//	DEVIF_UPD7759,
//	DEVIF_OKIM6258,
//	DEVIF_OKIM6295,
//	DEVIF_K051649,
//	DEVIF_K054539,
//	DEVIF_HUC6280,
//	DEVIF_C140,
//	DEVIF_K053260,
	DEVIF_POKEY,
//	DEVIF_QSOUND,
//	DEVIF_SCSP,
	DEVIF_MAX,
};

//萔


static const Char DEVIF_ChipStr[][7] = {
//	"BEEPAT", 
//	"BEEP98", 
	"S76489", 
	"YM2413",
	"YM2612",
	"YM2151",
//	"SGAPCM",
//	"RF5C68",
	"YM2203",
	"YM2608",
	"YM2610",
	"YM3812",
	"YM3526",
	"Y-8950",
	"YMF262",
	"YMF278",
	"YMF271",
//	"YMZ280",
//	"R5C164",
//	"PWAVEM", //S32X PWM
	"AY8910",
//	"GB-DMG",
//	"RP2A03",
//	"MLTPCM",
//	"UP7759",
//	"OK6258",
//	"OK6295",
//	"K51649",
//	"K54539",
//	"HU6280",
//	"K-C140",
//	"K53260",
	"APOKEY",
//	"QSOUND",
//	"YMF292",
//	"OM5232", //OKI MSM5232 ͂₭炵cI
};


//𐧌䂷C^[tF[X̃C^[tF[XB
//́Aopenreset[stack...stacksend]close
//͕gpƂʂɂ蓾̂ŁAϐmallocĎĂB

typedef struct {
	// IFJB0Ő
	Uint8 (*open) (void*, Uint8);

	// IFBϐ̉
	void  (*close)(void*);
	
	// ZbgB0Ő
	Uint8 (*reset)(void*);
	
	// f[^𗭂߂B0Ő@(, Num, Abus, Addr, Val)
	Uint8 (*push)(void*,Uint8,Uint8,Uint8,Uint8,Uint8);

	// ߍ񂾃f[^𑗐MB0Ő
	Uint8 (*send) (void*);

	// IF̏󋵂i[BԂBiMAX_PORTSTRȓj
	Uint32 (*info) (void*,Char*);

	// IFpϐBi[|C^
	void* p;

}SEND_INTERFACE;
#define s_open(d,x) (d)->open((d)->p,x)
#define s_close(d) (d)->close((d)->p)
#define s_reset(d) (d)->reset((d)->p)
#define s_push(d,v,w,x,y,z) (d)->push((d)->p,v,w,x,y,z)
#define s_send(d) (d)->send((d)->p)
#define s_info(d,x) (d)->info((d)->p,x)

//vC[̃fR[h̃C^[tF[XB
//́Aopenstart[drive...drive]stopclose
//͕gpȂAO[oϐłB

typedef struct _decode_interface {
	// t@CJB0Ő
	Uint8 (*open) (Char*);

	// t@CB0Ő
	void (*close)(void);
	
	// ĐJn̍}𑗂B0Ő
	Uint8 (*start)(Uint32);
	
	// Đ~̍}𑗂B0Ő
	Uint8 (*stop) (void);
	
	// w莞ԕi߂B̏܂ł̃EFCgԂԂB
	// i~bPʁB1bȂ1000j
	Double (*drive)(Double);
		
	// 擾B,obt@
	Uint32 (*info)(Uint32, Char*);
		
}DECODE_INTERFACE;
#define d_open(d,x)   ((d)->open  ? (d)->open(x) : -1)
#define d_close(d)    if((d)->close)(d)->close()
#define d_start(d,x)  ((d)->start ? (d)->start(x) : -1)
#define d_stop(d)     ((d)->stop  ? (d)->stop()  : -1)
#define d_drive(d,x)  ((d)->drive ? (d)->drive(x): -1)
#define d_info(d,x,y) ((d)->info  ? (d)->info(x,y): -1)

#endif

#define IF_SSTR_MAX 1024
extern Char if_sstr[IF_SSTR_MAX]; //foCXɂĂ̏

void rvs_ifopen();
void rvs_ifclose();
void rvs_reset();
void rvs_push(Uint8 chip, Uint8 num, Uint8 abus, Uint8 addr, Uint8 val);
void rvs_send();
Uint32 rvs_info(Uint8 num, Char* strp);

Uint8 rvd_open(DECODE_INTERFACE *dec, Char *path);

#ifdef __cplusplus
}
#endif